var BWjsonFile = FileLib.read("./config/ChatTriggers/modules/BwDailyStats/bwDailyStats.json");
var bwDailyStats = JSON.parse(BWjsonFile);
var currentDate = new Date().getDate();

var BedWarsDailyStatsShown = true;

TriggerRegister.registerCommand("toggleBWstats").setName("bwDailyStats");
TriggerRegister.registerCommand("toggleBWstats").setName("bwstats");
TriggerRegister.registerCommand("toggleBWstats").setName("bwstat");
function toggleBWstats(argument) {
	if (argument === "show") {
		BedWarsDailyStatsShown = true;
		ChatLib.chat("&r&aYour BedWars daily stats are now shown!&r");
		ChatLib.chat("&2&oDrag it around your screen to fit your needs &2&oand right click &2&oit &2&oto change &2&oits colors!");
	}                                                            
	else if (argument === "hide") {
		BedWarsDailyStatsShown = false;
		ChatLib.chat("&r&cYour BedWars daily stats are now hidden!&r");
	}
	else if (argument === "reset") {
		FileLib.write('./config/ChatTriggers/modules/VzDailyStats/vzDailyStats.json',
						'{"exp":0,"wins":0,"final_kills":0,"date written in the JSON":' + currentDate + '}');
		bwDailyStats["exp"] = 0;
		bwDailyStats["wins"] = 0;
		bwDailyStats["final_kills"] = 0;
		bwDailyStats["date written in the JSON"] = currentDate;
		ChatLib.chat("&4Your Bed Wars daily stats are now reset!&r");
	}
	else {
		ChatLib.chat("&cUsage: /bwdailystats <show|hide|reset>");
	}
}

TriggerRegister.registerChat("incrementExp").setChatCriteria("&r&b+${amount_of_exp} Bed Wars Experience").setParameter("contains");
function incrementExp(amount_of_exp) {
		bwDailyStats["exp"] += Number(amount_of_exp);
}

TriggerRegister.registerChat("incrementWins").setChatCriteria("&r&6+${amount_of_coins} coins! (Win)").setParameter("contains");
function incrementWins() {
	if (ChatLib.removeFormatting(Scoreboard.getTitle()) === "BEDWARS") { 
		bwDailyStats["wins"]++;
	}
}


TriggerRegister.registerChat("incrementFinalKills").setChatCriteria("&r&6+${amount_of_coins}coins! (Final Kill)").setParameter("contains");
function incrementFinalKills() {
	if (ChatLib.removeFormatting(Scoreboard.getTitle()) === "BEDWARS") { 
		bwDailyStats["final_kills"]++;
	}
}

/* The daily stats are stored in an external JSON file in order to ensure that the stats aren't reset at every minecraft/chattriggers reload */
register("gameUnload", function updateBedWarsJSON() {
	/* Save the data stored in the bwDailyStats object by writing it on the JSON file */
	FileLib.write('./config/ChatTriggers/modules/BwDailyStats/bwDailyStats.json',
	'{"exp":' + bwDailyStats["exp"] + ',"wins":' + bwDailyStats["wins"] + ',"final_kills":' 
	+ bwDailyStats["final_kills"] + ',"date written in the JSON":' + bwDailyStats["date written in the JSON"] + '}');
	BWjsonFile = FileLib.read("./config/ChatTriggers/modules/BwDailyStats/bwDailyStats.json");
	bwDailyStats = JSON.parse(BWjsonFile);
});

register("gameLoad", function resetStatsOfPreviousDay() {
	if (currentDate != bwDailyStats["date written in the JSON"]) {
		FileLib.write('./config/ChatTriggers/modules/BwDailyStats/bwDailyStats.json',
					'{"exp":0,"wins":0,"final_kills":0,"date written in the JSON":' + currentDate + '}')
		bwDailyStats["exp"] = 0;
		bwDailyStats["wins"] = 0;
		bwDailyStats["final_kills"] = 0;
		bwDailyStats["date written in the JSON"] = currentDate;
	}
});

xPosOfBedWarsStats = Number(FileLib.read('./config/ChatTriggers/modules/BwDailyStats/savedXPosOfBedWarsStats.txt'))	
yPosOfBedWarsStats = Number(FileLib.read('./config/ChatTriggers/modules/BwDailyStats/savedYPosOfBedWarsStats.txt'))

/* The color code values are doubled because the function(mouseX, mouseY, mouseButton) double-clicks */
colorCode = ["0", "0", "8", "8", "7", "7", "f", "f", "5", "5", "d", "d", "9", "9", "1", "1", "3", "3", "b", "b", "a", "a", "2", "2", "6", "6", "e", "e", "c", "c", "4", "4"];
BedWarsStatsColor = 7; /* the default value is the second "f" of the colorCode array */

register("renderOverlay", function renderingBWStatsOnScreen() {
	if (BedWarsDailyStatsShown) {
		Renderer.text("&" + colorCode[BedWarsStatsColor] + "&l&nBedWars Daily Stats", xPosOfBedWarsStats, yPosOfBedWarsStats).setShadow(true).setScale(1).draw();
		Renderer.text("&" + colorCode[BedWarsStatsColor] + "Experience: " + bwDailyStats["exp"], xPosOfBedWarsStats, yPosOfBedWarsStats+10).setShadow(true).setScale(1).draw();
		Renderer.text("&" + colorCode[BedWarsStatsColor] + "Wins: " + bwDailyStats["wins"], xPosOfBedWarsStats, yPosOfBedWarsStats+20).setShadow(true).setScale(1).draw();
		Renderer.text("&" + colorCode[BedWarsStatsColor] + "Final Kills: " + bwDailyStats["final_kills"], xPosOfBedWarsStats, yPosOfBedWarsStats+30).setShadow(true).setScale(1).draw();
	}
});

register("clicked", function bedwarsStatsClick(mouseX, mouseY, mouseButton) {
	if (Client.isInChat()) {
		if (mouseButton === 0) { /* left click */
			if (xPosOfBedWarsStats <= mouseX && mouseX < xPosOfBedWarsStats + 60 && yPosOfBedWarsStats <= mouseY && mouseY < yPosOfBedWarsStats+45) { /* check that the text is clicked */
				clickedAtTheBwText = true;
			}
			else {
				clickedAtTheBwText = false;
			}
		}
		else if (mouseButton === 1) { /* right click */ 
			if (xPosOfBedWarsStats <= mouseX && mouseX < xPosOfBedWarsStats + 60 && yPosOfBedWarsStats <= mouseY && mouseY < yPosOfBedWarsStats+45) {
				if (0 <= BedWarsStatsColor && BedWarsStatsColor < 32) {
					BedWarsStatsColor++;
				}
				if (BedWarsStatsColor === 32) {
					BedWarsStatsColor = 0;
				}
			}
		}
	}
});

register("dragged", function bedwarsStatsDrag(dx, dy) {
	if (Client.isInChat()) {
		if (clickedAtTheBwText) {
			xPosOfBedWarsStats += dx
			yPosOfBedWarsStats += dy
		}
	}
});

register("gameUnload", function saveCoordsOfBWStats() {
	FileLib.write('./config/ChatTriggers/modules/BwDailyStats/savedXPosOfBedWarsStats.txt', xPosOfBedWarsStats);
	FileLib.write('./config/ChatTriggers/modules/BwDailyStats/savedYPosOfBedWarsStats.txt', yPosOfBedWarsStats);
});

register("gameLoad", function showUpdateLog() {
	var  ctjsDiscordInviteLink = new TextComponent("&e ⇒ https://discord.gg/0fNjZyopOvBHZyG8").setClick("open_url", "https://discord.gg/0fNjZyopOvBHZyG8").setHoverValue("Click to open the discord invite link");
	if (FileLib.read('./config/ChatTriggers/modules/BwDailyStats/isUpdateLogSeen.txt') === "false") {
		ChatLib.chat("&m--------------&r &a&lBedWars Daily Stats&r &m--------------");
		ChatLib.chat("The module updated to version " + "&e1.3&r!");
		ChatLib.chat("Read more below to learn about what's new in this version :");
		ChatLib.chat("                                             ");
		ChatLib.chat("• Changed how the command (/bwdailystats) works");
		ChatLib.chat("• Added a command to force reset the stats: /bwdailystats reset &7(\u26A0 There is no confirmation \u26A0)");
		ChatLib.chat("• Fixed a bug that prevented stats from saving");
		ChatLib.chat("• Changed the default X position of the stats on the screen (it was appearing outside of the screen for people playing in small window)");
		ChatLib.chat("                                             ");
		ChatLib.chat("&eIf you encounter &eany problems &eor &ebugs, &eplease &elet &eme &eknow &ein &ethe &eChatTriggers &eDiscord &eserver:");
		ChatLib.chat(ctjsDiscordInviteLink);
		ChatLib.chat("&m--------------&r &a&lBedWars Daily Stats&r &m--------------");
		
		FileLib.write('./config/ChatTriggers/modules/BwDailyStats/isUpdateLogSeen.txt', "true");
	}
});